Description

Issues:

- when trying to provision a VM in a vsphere environment that doesn't have clusters, and only hosts, the dropdown for clusters is

empty and creating it indicates that "cluster is required for this operation"

- It allows you to select a local data store on a different host than you are creating the VM on.

Related issues:

Related to Foreman - Feature #1946: Addition VMWare options required for VM c... Resolved 11/15/2012

Related to Foreman - Bug #2666: Unable to create new host Rejected 06/13/2013

Has duplicate Foreman - Bug #8528: Provisioning on a non-clustered ESXi Duplicate 11/27/2014

Blocked by Foreman - Refactor #8357: Update fog version to 1.25.x Closed 11/12/2014

History

#1 - 11/30/2012 09:40 AM - Brian Gupta

- Target version set to 1.1

#2 - 12/03/2012 07:48 AM - Ohad Levy

while a hack, this patch can solve the issue in the meantime:

diff --git a/lib/fog/vsphere/requests/compute/list_clusters.rb b/lib/fog/vsphere/requests/compute/list_cluster

s.rb

index 2092213..55980c7 100644

--- a/lib/fog/vsphere/requests/compute/list_clusters.rb

+++ b/lib/fog/vsphere/requests/compute/list_clusters.rb

@@ -11,7 +11,7 @@ module Fog

         end

         def raw_clusters(datacenter)

-          find_raw_datacenter(datacenter).hostFolder.childEntity.grep(RbVmomi::VIM::ClusterComputeResource)

+          find_raw_datacenter(datacenter).hostFolder.childEntity.grep(RbVmomi::VIM::ComputeResource)

         end

#3 - 01/02/2013 07:18 AM - Ohad Levy

- Target version deleted (1.1)

#4 - 05/13/2013 12:23 PM - Mikael Fridh

Ohad Levy wrote:

while a hack, this patch can solve the issue in the meantime:

[...]

 Patch works wonders! Thanks Ohad.
#5 - 06/12/2013 02:16 PM - Dominic Cleal

- Target version set to 1.3.0

#6 - 07/16/2013 10:04 AM - Oliver Weinmann

Hi,

this no longer seems to work in Foreman 1.2.

I have a Vsphere 5.0 cluster that works fine but the standalone ESXi 5.1 throws an error:

Failed to save: Failed to destroy a compute esxi51 (VMWare) instance centos.a.space.corp: unexpected path class NilClass, mac value is blank!,

Failed to destroy a compute esxi51 (VMWare) instance centos.a.space.corp: unexpected path class NilClass

#7 - 09/16/2013 11:49 AM - Lukas Zapletal

- Target version changed from 1.3.0 to 1.4.0

#8 - 10/16/2013 03:37 PM - Greg Sutcliffe

- Target version deleted (1.4.0)

#9 - 12/10/2013 01:17 PM - Anonymous

According to a discussion on IRC, this is still present at least in 1.3.1.

#10 - 02/14/2014 04:08 PM - Ben Fairless

I can confirm this issue, and also Ohad's workaround, is still present in 1.4.0

#11 - 02/27/2014 03:45 PM - Benjamin Papillon

- Related to Bug #2666: Unable to create new host  added

#12 - 07/02/2014 05:58 AM - Marco De Vitis

I confirm this bug is still present in Foreman 1.5.1, and Ohad's patch works.

#13 - 07/25/2014 05:54 PM - Derek Tamsen

I can also confirm this issue still exists in Foreman 1.5.1. However, the patch only works if their are no organizational folders in vsphere for the cluster

group. If a cluster is organized into folder(s) under a datacenter, foreman fails to see any clusters. This seems like an underlying issue with either fog

or rbvmomi though.

Working Example with Patch:

vcenterserver -> datacenter chosen in dropdown menu -> cluster(s)

Non working example with patch or without patch:

vcenterserver -> datacenter chosen in dropdown menu -> folder1 -> folder2 -> cluster(s)

#14 - 09/17/2014 10:39 AM - Dominic Cleal

- Bugzilla link set to 1142878

#15 - 09/18/2014 04:59 AM - Dominic Cleal

- Category changed from VM management to Compute resources - VMware

Derek, re comment 14, I've logged that cluster-in-a-folder issue as #7518 leaving this ticket specifically for non-cluster setups.

#16 - 10/11/2014 12:46 PM - Alexander Korolev

Just tested with vSphere 5.5. over vCenter on a single host (former cluster) - works fine without any issues.

Structure is as Follows:

vCenter |- Cluster (no HA/DRS active)   |- Single host       |- test vm

#17 - 10/24/2014 10:48 AM - Slava Bendersky

Hello Everyone,

Is there availble work arrounds ? In my case it is blocker I can't deploy any new vms.

My case

Vcenter --- DataCenter01
_ Host01    |              |_________ Host02    |    |______ DataCenter02

#18 - 10/24/2014 10:51 AM - Slava Bendersky

My case

Vcenter --- DataCenter01

  |                 |_ Host01

  |                 |__Host02

  |

  |______ DataCenter02

                 |_ Host01

                 |__Host02

and so on

#19 - 11/12/2014 07:16 AM - Shlomi Zadok

- Assignee set to Shlomi Zadok

#20 - 11/12/2014 07:22 AM - Shlomi Zadok

- Blocked by Refactor #8357: Update fog version to 1.25.x added

#21 - 11/14/2014 07:55 PM - Slava Bendersky

I tried today on 1.7RC1 and patch not working any more. Cluster field is empty.

#22 - 11/14/2014 08:12 PM - Slava Bendersky

ok after reboot patch fog 1.24 and it working.

#23 - 11/14/2014 08:39 PM - Slava Bendersky

Slava Bendersky wrote:

ok after reboot patch for fog 1.24 working as expected.

#24 - 11/26/2014 07:39 AM - Dominic Cleal

- Status changed from New to Closed

- % Done changed from 0 to 100

- translation missing: en.field_release set to 29

https://github.com/fog/fog/commit/66e5521

#25 - 11/27/2014 11:00 AM - Dominic Cleal

- Related to Bug #8528: Provisioning on a non-clustered ESXi added

#26 - 12/05/2014 03:58 AM - Dominic Cleal

- translation missing: en.field_release changed from 29 to 28

#27 - 03/02/2015 06:27 AM - Dominic Cleal

- Related to deleted (Bug #8528: Provisioning on a non-clustered ESXi)

#28 - 03/02/2015 06:27 AM - Dominic Cleal

- Blocked by Bug #8528: Provisioning on a non-clustered ESXi added

#29 - 03/02/2015 06:29 AM - Dominic Cleal

- Status changed from Closed to New

- Assignee deleted (Shlomi Zadok)

- translation missing: en.field_release deleted (28)

Removing from the 1.8.0 release target, as based on the discussion surrounding #8528, I remain unconvinced that this is supported.  The patch in

Fog only appears to be part of the solution, a more fundamental problem about MAC address allocations and Foreman's compute orchestration

remains.

#30 - 03/02/2015 07:44 AM - Shlomi Zadok
So it is a regression? (it is working on 1.7.x)

#31 - 03/02/2015 07:50 AM - Dominic Cleal

Shlomi Zadok wrote:

So it is a regression? (it is working on 1.7.x)

 1.7 doesn't even have the Fog patch.  I don't see how this is a regression, it's never functioned.

#32 - 05/20/2017 07:28 AM - Anonymous

- Blocked by deleted (Bug #8528: Provisioning on a non-clustered ESXi)

#33 - 05/20/2017 07:28 AM - Anonymous

- Has duplicate Bug #8528: Provisioning on a non-clustered ESXi added

#34 - 05/20/2017 07:29 AM - Anonymous

Before there's no fog update which is bringing this feature, there's no possibility on the Foreman side to fix this.

#35 - 03/19/2018 01:48 PM - Bryan Kearney

@michael is there a fog upstream issue we should be tracking for this?

#36 - 05/17/2018 05:32 PM - Chris Roberts

- Assignee set to Chris Roberts

- Difficulty set to medium

#37 - 05/18/2018 05:18 PM - Eric Hansen

I started hitting something like this after upgrading from 1.16rc2 to 1.17.  The problem was not evident in 1.16rc2.  Now, when I try to deploy on a

host, I see that the cluster field is populated as "Please select a cluster".  The ESXi host is a standalone in the datacenter.  When deploying to this

datacenter, the deployment now fails with the following, but I had it working in 1.16rc2,

2018-05-18 13:02:54 5312b229 [app] [W] Failed to create a compute dev5vcenter-QA-Databases (VMware) instance eh-katello.qa.catalogic.us:

undefined method `resourcePool' for #<RbVmomi::VIM::Folder:0x00007f9db47ec670>  |  | NoMethodError: undefined method `resourcePool' for

#<RbVmomi::VIM::Folder:0x00007f9db47ec670>  |

/opt/theforeman/tfm/root/usr/share/gems/gems/fog-vsphere-2.1.0/lib/fog/vsphere/requests/compute/get_resource_pool.rb:16:in

`get_raw_resource_pool'  | /opt/theforeman/tfm/root/usr/share/gems/gems/fog-vsphere-2.1.0/lib/fog/vsphere/requests/compute/create_vm.rb:25:in

`create_vm'  | /opt/theforeman/tfm/root/usr/share/gems/gems/fog-vsphere-2.1.0/lib/fog/vsphere/models/compute/server.rb:303:in `save'  |

/usr/share/foreman/app/models/compute_resources/foreman/model/vmware.rb:447:in `create_vm'  |

/usr/share/foreman/app/models/concerns/orchestration/compute.rb:77:in `setCompute'  |

/usr/share/foreman/app/models/concerns/orchestration.rb:222:in `execute'  | /usr/share/foreman/app/models/concerns/orchestration.rb:145:in `block in

process'  | /usr/share/foreman/app/models/concerns/orchestration.rb:137:in `each'  | /usr/share/foreman/app/models/concerns/orchestration.rb:137:in

`process'  | /usr/share/foreman/app/models/concerns/orchestration.rb:44:in `around_save_orchestration'  |

/opt/theforeman/tfm-ror51/root/usr/share/gems/gems/activesupport-5.1.4/lib/active_support/callbacks.rb:117:in `block in run_callbacks'

#38 - 05/18/2018 05:44 PM - Eric Hansen

FYI, my problem was resolved by adding a cluster to the datacenter and moving the ESX host into it, so that's definitely the problem.

#39 - 08/23/2018 08:00 PM - Chris Roberts

- Status changed from New to Resolved

- Triaged changed from No to Yes

- Pull request https://github.com/fog/fog-vsphere/pull/149 added

- Fixed in Releases 1.19.0 added

#40 - 08/23/2018 08:00 PM - Chris Roberts

Part of the fog-vsphere 2.3.0 gem found in 1.19 marking as resolved.

#41 - 01/31/2019 05:20 PM - Eric Hansen

Was this ever tested?

Although I now see stand-alone hosts in the UI, trying to provision to them fails.  I am on Foreman 1.20.1.  The logs show,

2019-01-31T11:27:24 [I|app|cdd3a] Processed 1 tasks from queue 'Host::Managed Main', completed 0/5
2019-01-31T11:27:24 [E|app|cdd3a] Task 'Set up compute instance joey-tafoya.qa.catalogic.us' failed

2019-01-31T11:27:24 [E|app|cdd3a] Task 'Query instance details for joey-tafoya.qa.catalogic.us' canceled

2019-01-31T11:27:24 [E|app|cdd3a] Task 'Create IPv4 DNS record for joey-tafoya.qa.catalogic.us' canceled

2019-01-31T11:27:24 [E|app|cdd3a] Task 'Create Reverse IPv4 DNS record for joey-tafoya.qa.catalogic.us' canceled

2019-01-31T11:27:24 [E|app|cdd3a] Task 'Power up compute instance joey-tafoya.qa.catalogic.us' canceled

2019-01-31T11:27:24 [I|app|4e73a]   Rendering text template

2019-01-31T11:27:24 [I|app|4e73a]   Rendered text template (0.0ms)

2019-01-31T11:27:24 [I|app|4e73a] Completed 200 OK in 232ms (Views: 0.9ms | ActiveRecord: 43.5ms)

2019-01-31T11:27:24 [E|app|cdd3a] Failed to save: Failed to create a compute eng1vcenter-Apps-DC (VMware) instance joey-tafoya.qa.catalogic.us:

CannotAccessVmComponent: A component of the virtual machine is not accessible on the host.

#42 - 01/31/2019 08:38 PM - Chris Roberts

- Status changed from Resolved to Need more information

Eric,

Do you have the full traceback from the production.log that I can see? As far as it being tested yes it should have been. I have about 16 tests that I

run for regression besides testing the main feature. It was quite a bit ago so I apologize for not having that answer off hand.

#43 - 01/31/2019 08:41 PM - Chris Roberts

Eric,

It was tested in our downstream product here:

https://bugzilla.redhat.com/show_bug.cgi?id=1596858#c7

#44 - 04/15/2019 09:26 PM - Chris Roberts

- Status changed from Need more information to Closed

#45 - 09/21/2020 10:19 AM - Luca Lesinigo

sorry to resurrect this, but I recently tried with a fresh install of Foreman 2.1.2 and I cannot provision VMs on standalone VMware hosts (tried with an

ESXi 5.5 and an ESXi 6.7 hosts, with different errors).

Documentation clearly says Only VMware clusters using vSphere are supported, not standalone ESX or ESXi servers but then links to this issue

which is marked as closed and Fixed in Releases: 1.19.0 and it also contains comments like "marking as resolved". As a user reading documentation

and this issue, the whole thing sounds a little confusing to me.

As far as I can understand, it still stands that standalone hosts are not supported and getting errors like I did is to be expected, even if this issue and

some linked ones (also on RH Satellite) sounds like resolved. Can someone please clarify if this is correct?
